<?php
/**
 * Created by PhpStorm.
 * User: crose
 * Date: 1/29/16
 * Time: 8:03 AM
 */

namespace qfq;

require_once(__DIR__ . '/../../qfq/store/Store.php');


class AbstractException extends \Exception {

    public $messageArray = array();
    public $store;

    protected $file = '';
    protected $line = '';


    /**
     * @return string
     */
    public function formatException() {
        $debug = '';
        $store = Store::getInstance();
        $html = '';

        $this->messageArray['File'] = $this->getFile();
        $this->messageArray['Line'] = $this->getLine();
        $this->messageArray['Message'] = $this->getMessage();
        $this->messageArray['Code'] = $this->getCode();
        $this->messageArray['Stacktrace'] = '<pre>' . $this->getTraceAsString() . '</pre>';
        $this->messageArray['Page Id'] = $store->getVar(TYPO3_PAGE_ID, STORE_TYPO3);
        $this->messageArray['Content Id'] = $store->getVar(TYPO3_TT_CONTENT_UID, STORE_TYPO3);

        $html .= "Code: " . $this->messageArray['Code'] . "<br>";
        $html .= "Message: " . Support::wrapTag("<strong>", $this->messageArray['Message']) . "</br>";

        if (isset($this->messageArray['Form'])) {
            $html .= "Form: " . Support::wrapTag("<strong>", $this->messageArray['Form']) . "</br>";
        }

        if (isset($this->messageArray['Form Element'])) {
            $html .= "Form Element: " . Support::wrapTag("<strong>", $this->messageArray['Form Element']) . "</br>";
        }

        $html = "<h2>Error</h2>" . Support::wrapTag('<p>', $html);
        $html = Support::wrapTag("<div class='warning'>", $html);

        if ($store->getVar(SYSTEM_SHOW_DEBUG_INFO, STORE_SYSTEM) === 'yes') {

            // Layout
            $debug = '<tr bgcolor="#dddddd"><td colspan="2">Exception</td></tr>';
            foreach ($this->messageArray as $key => $value) {
                if (is_array($value)) {
                    $value = var_export($value, true);
                }

                if ($value !== '' && $value !== false)
                    $debug .= "<tr>" . "<td>$key</td>" . "<td>$value</td>" . "</tr>";
            }
            $debug = "<table border=1>" . $debug . "</table>";
        }
        return $html . $debug;
    }

}